/* GCC */
#include<stdio.h>
#include<vector>
#include<algorithm>
#include<queue>
#include<string.h>
using namespace std;
int gcd(int a, int b) {return((b==0)?a:gcd(b, a%b));};
struct fract
{
    int ch, zn;
} sam;
void k_sim(int *a, int *b)
{
    int k = gcd(*a, *b);
    if (k == 1) return; else
    {
        *a = *a/k;
        *b = *b/k;
        return;
    }
}
fract f_summ(fract i1, fract i2)
{
    fract ans;
    ans.ch = i1.ch*i2.zn + i2.ch*i1.zn;
    ans.zn = i1.zn*i2.zn;
    k_sim(&ans.ch, &ans.zn);
    return ans;
}
fract f_mult(fract i1, fract i2)
{
    fract ans;
    ans.ch = i1.ch*i2.ch;
    ans.zn = i1.ch*i2.zn + i2.ch*i1.zn;
    k_sim(&ans.ch, &ans.zn);
    return ans;
}
main()
{
    FILE *fi = fopen("resistor.in", "r"), *fo = fopen("resistor.out", "w");
    int n, m, p1, p2;
    fscanf(fi, "%d%d", &n, &m);
    vector<fract> v[n];
    for (int i=0; i<n; i++)
    {
        v[i].resize(n);
        for (int j=0; j<n; j++)
        {
            v[i][j].ch = -1;
            v[i][j].zn = 0;
        }
    }
    for (int i = 0; i<m; i++)
    {
        fscanf(fi, "%d%d%d%d", &p1, &p2, &sam.ch, &sam.zn);
        if (p1 == p2) continue;
        p1--;
        p2--;
        k_sim(&sam.ch, &sam.zn);
        if (v[p1][p2].zn == 0) v[p1][p2] = sam; else v[p1][p2] = f_mult(sam, v[p1][p2]);
        v[p2][p1] = v[p1][p2];
    }
    queue<int> q, rb;
    q.push(0);
    int stv[2600], tmp; memset(stv, 0, sizeof(stv));
    stv[0] = 1;
    while (q.size() != 0)
    {
        tmp = q.front();
        q.pop();
        for (int i=0; i<n; i++) if (v[tmp][i].ch == 0 && stv[i] == 0)
        {
            stv[i] = 1;
            q.push(i);
        }
    }
    if (stv[n-1] == 1)
    {
        fprintf(fo, "0\n");
        fclose(fi);
        fclose(fo);
        return 0;
    }
    int fv[2600];
    for (int i=0; i<n; i++) stv[i] = -1;
    q.push(0); stv[0] = 0;
    while (q.size() != 0)
    {
        tmp = q.front();
        q.pop();
        for (int i=0; i<n; i++) if (v[tmp][i].zn != 0)
        {
            stv[tmp]++;
            if (stv[tmp] == 1) fv[tmp] = i;
            if (stv[i] == -1)
            {
                stv[i] = 0;
                q.push(i);
            }
        }
        if (stv[tmp] == 1 && tmp != 0 && tmp != n-1) rb.push(tmp);
    }
    if (stv[n-1] == -1)
    {
        fprintf(fo, "Zero conductivity\n");
        fclose(fi);
        fclose(fo);
        return 0;
    }
    while (rb.size() != 0)
    {
        tmp = rb.front();
        rb.pop();
        if (v[stv[tmp]][tmp].zn == 0) for (int i=0; i<n; i++) if (v[tmp][i].zn != 0)
        {
            stv[tmp] = i;
            break;
        }
        v[tmp][stv[tmp]].zn = 0;
        v[tmp][stv[tmp]].ch = -1;
        v[stv[tmp]][tmp].zn = 0;
        v[stv[tmp]][tmp].ch = -1;
        stv[stv[tmp]]--;
        if (stv[stv[tmp]] == 1) rb.push(stv[tmp]);
        stv[tmp] = 0;
    }
    p1 = 1;
    int x1, x2;
    vector<int> w;
    while (p1)
    { p1 = 0;
        for (int i=1; i<n-1; i++) if (stv[i] == 2)
        {
            p1 = 1;
            q.push(i);
        }
        while (q.size() != 0)
        {
            tmp = q.front();
            q.pop(); w.clear();
            for (int i = 0; i<n; i++) if (v[tmp][i].zn != 0) w.push_back(i);
            x1 = w[0]; x2 = w[1];
            sam = f_summ(v[tmp][x1], v[tmp][x2]);
            v[tmp][x1].zn = 0;
            v[tmp][x2].zn = 0;
            v[x1][tmp].zn = 0;
            v[x2][tmp].zn = 0;
            stv[tmp] = 0;
            stv[x1]--;
            stv[x2]--;
            if (v[x1][x2].zn == 0) v[x1][x2] = sam; else v[x1][x2] = f_mult(sam, v[x1][x2]);
            v[x2][x1] = v[x1][x2];
        }
    }
    fprintf(fo, "%d", v[0][n-1].ch);
    if (v[0][n-1].zn != 1) fprintf(fo, "/%d", v[0][n-1].zn);
    fprintf(fo, "\n");

    fclose(fi);
    fclose(fo);
    return 0;
}
